diff --git a/src/flb_mp.c b/src/flb_mp.c
index 39e331052a..d0888d80f3 100644
--- a/src/flb_mp.c
+++ b/src/flb_mp.c
@@ -38,7 +38,7 @@ static inline int mp_count(void *data, size_t bytes, msgpack_zone *zone)
         t = zone;
     }
 
-    while (msgpack_unpack(data, bytes, &off, t, &obj)) {
+    while (msgpack_unpack(data, bytes, &off, t, &obj) == MSGPACK_UNPACK_SUCCESS) {
         c++;
     }
 
